/*******************************************************
 * Bridge ⥸塼
 * 
 * /usr/local/bin/gcc -D_KERNEL brdg.c -c
 * ld -dn -r brdg.o -o brdg
 * 
 *******************************************************/

#include <netinet/in.h>
#include <inet/common.h>
#include <netinet/ip6.h>
#include <inet/ip.h>
#include <inet/tcp.h>
#include <sys/signal.h>
#include <sys/errno.h>
#include <sys/cred.h>
#include <sys/stat.h>
#include <sys/conf.h>
#include <sys/kmem.h>
#include <sys/dlpi.h>
#include <sys/ethernet.h>

#include <sys/modctl.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stream.h>
#include <sys/stropts.h>
#include <sys/ddi.h>
#include <sys/sunddi.h>
#include <sys/cmn_err.h>

//#define  DEBUG 
#define  MAXPORT 5    /* Ͽǽʺݡȿʥͥåȥ󥿡ե*/
#define  MAXHASH 1024 /* Ͽǽʺȯͥåȥɥ쥹 */
#define  MAX_MSG 256  /* SYSLOG ˽Ϥåκʸ */

static int  brdg_open (queue_t*, dev_t*, int, int, cred_t*);
static int  brdg_close (queue_t*, int, int, cred_t*);
static int  brdg_wput (queue_t*, mblk_t*);
static int  brdg_rput (queue_t*, mblk_t*);
static int  brdg_rput_data (queue_t*, mblk_t*);
static void brdg_add_port (queue_t*, mblk_t*);
static void brdg_remove_port (queue_t*, mblk_t*);
static void brdg_register_node (queue_t *, mblk_t *);
static void brdg_print (int , char *, ...);

/*
 * ݡȹ¤Ρ
 * ĤΥݡȹ¤Τbrdgadm ޥɤɲä룱ĤΥͥåȥ󥿡եб
 * brdgadm ޥɤˤ STREAM  PUSH 줿 brdg ⥸塼 readqueue Υɥ쥹ġ
 * brdg ⥸塼뤬ɤ줿ʳǡMAXPORT׿ʬΰ褬ݤ졢port_list[] 뤳Ȥ
 * äƤݡȹ¤ΤλȤǽ
 */
typedef struct port_s
{
    queue_t  *rqueue;   /* ΥݡȤб brdg ⥸塼 read queue */
    char     *ifname;   /* ΥݡȤΥ󥿡ե̾ȤƤʤ */
    uint32_t muxid;     /* ȤƤʤ */
} port_t;

port_t port_list[MAXPORT];

/*
 * node ¤
 * ȯͥåȥɥ쥹ˣ¸ߤ롣
 * ǽ˥ѥåȤϿ롣
 * ݡȤϿƤˤäơѥåȤݡȤ˺٥ѥåȤ
 * žƤޤΤɤȤǤ롣
 * ι¤Τ node_hash_table[] ϥåơ֥ˤʤäƤꡢͥåȥɥ쥹
 * ϥåͤ򻻽Фȯͥåȥɥ쥹ι¤ΤФȤǤ롣
 */ 
typedef struct node_s
{
    struct    ether_addr ether_addr; /* ȯͥåȥɥ쥹 */
    port_t    *port;                 /* ȯΥۥȤľܷҤäƤݡ */
    uint16_t  state;
} node_t;

node_t node_hash_table[MAXHASH];

/*
 * Ethernet Address ϥåͤ򻻽 [0-MAXHASH]
 * ׺ƹ
 */
#define ETHER_HASH(ether_addr) \
              (\
                   ((uint8_t)ether_addr.ether_addr_octet[0]    ) + \
                   ((uint8_t)ether_addr.ether_addr_octet[1]<<8 ) + \
                   ((uint8_t)ether_addr.ether_addr_octet[2]    ) + \
                   ((uint8_t)ether_addr.ether_addr_octet[3]<<8 ) + \
                   ((uint8_t)ether_addr.ether_addr_octet[4]    ) + \
                   ((uint8_t)ether_addr.ether_addr_octet[5]<<8 )   \
               ) % MAXHASH

/*
 * DEBUG Ѥνϥ롼
 * cmn_err(9F) ˤ syslog ˥åϤ롣
 * DEBUG  on ˤȡʤΥå󥰤롣
 */
#ifdef DEBUG
#define BRDG_PRINT_ETHER(str, ether_addr) \
            brdg_print(CE_CONT,"%s %x:%x:%x:%x:%x:%x\n", \
                    str,\
                    (uint8_t)ether_addr.ether_addr_octet[0],\
                    (uint8_t)ether_addr.ether_addr_octet[1],\
                    (uint8_t)ether_addr.ether_addr_octet[2],\
                    (uint8_t)ether_addr.ether_addr_octet[3],\
                    (uint8_t)ether_addr.ether_addr_octet[4],\
                    (uint8_t)ether_addr.ether_addr_octet[5])

#define  BRDG_PRINT0(level, format)\
                         brdg_print(level, format)
#define  BRDG_PRINT1(level, format, va1)\
                         brdg_print(level, format, va1)
#define  BRDG_PRINT2(level, format, va1, va2)\
                         brdg_print(level, format, va1, va2)
#define  BRDG_PRINT3(level, format, va1, va2, va3)\
                         brdg_print(level, format, va1, va2, va3)
#define  BRDG_PRINT7(level, format, va1, va2, va3, va4, va5, va6, va7)\
                         brdg_print(level, format, va1, va2, va4, va5, va6, va7)
#else
#define  BRDG_PRINT_ETHER
#define  BRDG_PRINT0
#define  BRDG_PRINT1
#define  BRDG_PRINT2
#define  BRDG_PRINT3
#define  BRDG_PRINT7
#endif

static struct module_info minfo = {
    0xabbe, "brdg", 0, INFPSZ, 512, 128 
};

static struct qinit brdg_rinit = { 
    brdg_rput, NULL, brdg_open, brdg_close, NULL, &minfo, NULL 
};

static struct qinit brdg_winit = { 
    brdg_wput, NULL, NULL, NULL, NULL, &minfo, NULL 
};

struct streamtab brdg_info = {
    &brdg_rinit, &brdg_winit, NULL, NULL
};

static struct fmodsw brdg_fmodsw ={
    "brdg", &brdg_info, (D_NEW|D_MP|D_MTQPAIR|D_MTOUTPERIM)
};

struct modlstrmod modlstrmod ={  
  &mod_strmodops, "bridge module(v1.13)", &brdg_fmodsw
};

static struct modlinkage modlinkage =
{
    MODREV_1, (void *)&modlstrmod, NULL                    
};

int
_init()
{
        int err;
        BRDG_PRINT0(CE_CONT,"Entering _init()\n");        
        err = mod_install(&modlinkage);
        return err;
}

int
_info(struct modinfo *modinfop)
{
    int err;
    BRDG_PRINT0(CE_CONT,"Entering _info()\n");    
    err = mod_info(&modlinkage, modinfop);
    return err;
}

int
_fini()
{
    int err;
    BRDG_PRINT0(CE_CONT,"Entering _finit()\n");    
    err =  mod_remove(&modlinkage);
    return err;
}


/**********************************************************************
 * brdg_open()
 * brdg ⥸塼Υץ롼
 * brdbadm -a ޥɤˤƥ󥿡եɲä줿Ȥ˸ƤФ
 **********************************************************************/
static int
brdg_open(queue_t* q, dev_t *devp, int oflag, int sflag, cred_t *cred)
{
    port_t   *port;
    uint32_t portnum;

    BRDG_PRINT0(CE_CONT,"Entering brdg_open()\n");
    if (sflag != MODOPEN) {
        return EINVAL;
    }
    
    for (portnum = 0; portnum < MAXPORT; portnum++){
        if (port_list[portnum].rqueue == NULL){
            port_list[portnum].rqueue = q;
            port = &port_list[portnum];            
            break;
        }
    }

    if (portnum >= MAXPORT)
        return(ENXIO);    
    /*
     * ReadWrite ξɤ q_ptr  port_s ¤Τؤ
     * ݥ󥿡򥻥å
     */
    q->q_ptr = WR(q)->q_ptr = port;
    qprocson(q);
    return(0);    
}

/**********************************************************************
 * brdg_open()
 * brdg ⥸塼Υ롼
 * brdbadm -d ޥɤˤƥ󥿡եȤ˸ƤФ
 **********************************************************************/
static int brdg_close (queue_t *q, int flag, int sflag, cred_t *cred)
{
    port_t *port;
    node_t *node;
    uint32_t nodenum;
    
    BRDG_PRINT0(CE_CONT,"Entering brdg_close()\n");    
    port = q->q_ptr;
    /*
     *  queue  putڤservice롼̵ˤ
     */
    qprocsoff(q);
    /*
     *  queue ˴Ϣ node ȥõ
     */
    for ( nodenum =0 ; nodenum < MAXHASH ; nodenum++){
        node = &node_hash_table[nodenum];
        if ( node->port != NULL && node->port->rqueue == q){
            node->port = NULL;
        }
    }
    port->rqueue= NULL; 
    /*
     * readwrite queue  port_t ¤ΤؤΥ󥯤Ϥ
     */
    q->q_ptr = WR(q)->q_ptr = NULL;
    return(0);
}

/*************************************************************************
 * brdg_wput()
 * brdg ⥸塼 write put ³
 * STREAM ξ夷 message νԤ
 * Υ⥸塼ξ硢Υ⥸塼 IP module ˤʤΤǡ
 * ïƤФʤϤ(IP  putnext(9F) Ƥ뤳ȤϤʤ)
 * 
 *  
 *           q:  queue ¤ΤΥݥ
 *          mp:  message block Υݥ
 * ͡
 *           ʤ  
 *************************************************************************/
static int
brdg_wput(queue_t *q, mblk_t *mp)
{
    struct iocblk *iocp;

    BRDG_PRINT0(CE_CONT,"Entering brdg_wput()\n");
    
    putnext(q, mp);
    return(0);
}

/**********************************************************************
 * brdg_rput()
 * brdg ⥸塼 read put ³
 * 
 * STREAM β夷åνԤ
 * ϥ󥿡եɥ饤Ф putnext(9F) ƤФ롣
 * åΥפ M_DATA äˤ brdg_rput_data() Ƥ֡
 * 
 *  
 *           q:  queue ¤ΤΥݥ
 *          mp:  message block Υݥ
 * ͡
 *           ʤ
 ***********************************************************************/
static int
brdg_rput(queue_t *q, mblk_t *mp)
{
    struct     ether_header *ether;
    uchar_t    *rptr;       /* message  read ݥ */
    node_t     *snode;      /* ԤΥꥹȤǤ node_s ¤ */
    port_t     *port;       /*  queue  q_ptr  port ¤ */
    
    switch(mp->b_datap->db_type) {
        case M_FLUSH:
            if (*mp->b_rptr & FLUSHW) {
                *mp->b_rptr &= ~FLUSHR;
                qreply(q, mp);
            }
            else
                freemsg(mp);
            return(0);
        case M_ERROR:
        case M_HANGUP:
            freemsg(mp);
            return(0);
        case M_DATA:
            rptr = mp->b_rptr; /* message  read pointer */           
            ether = (struct ether_header *)&rptr[0];
            snode = &node_hash_table[ETHER_HASH(ether->ether_shost)];

            if(snode->port == NULL){
                /*
                 * hash table  node ˤޤϿƤʤ
                 * ХǡѹΤǡ¾⡼ɤ˥åץ졼
                 * qwriter(9F) ƤФ륳Хåؿ򤹤˼¹Ԥ뤿ˤ
                 * qwrite(9F) 塢ľ return() ɬפ롣
                 * Ǥʤȡ thread λޤǥХåؿԤ
                 */
                BRDG_PRINT0(CE_CONT,"Node not registerd. Register new node\n");
                qwriter(q, mp, brdg_register_node, PERIM_OUTER);
                return(0);
            } else if(bcmp(&ether->ether_shost, &snode->ether_addr, ETHERADDRL)){
                /*
                 * node ϥåơ֥ node Υͥåȥɥ쥹ͥå
                 * ƱǤ̵ϥåͤʣΤȻפ
                 */
                BRDG_PRINT0(CE_CONT,"Node address is confrict!!!!\n");
                BRDG_PRINT_ETHER("confrict source addr = ", ether->ether_shost);
                BRDG_PRINT_ETHER("confrict node  addr  = ", snode->ether_addr );
                qwriter(q, mp, brdg_register_node, PERIM_OUTER);
                return(0);
            }  
            brdg_rput_data(q, mp);
            return(0);
        default:
            freemsg(mp);
            return(0);
    } /* switch() END */
    BRDG_PRINT0(CE_CONT, "brdg_rput(). We shouldn't be here. Something Wrong!!!!\n");
    return(0);
}

/**********************************************************************
 * brdg_rput_data()
 * brdg ⥸塼 M_DATA å read put ³
 *
 * brdg_rput()⤷ brdg_register_node() ƤФ롣
 * ¾Υ󥿡ե  STREAM  queue إå putnext(9F)  
 * 
 *  
 *           q:  queue ¤ΤΥݥ
 *          mp:  message block Υݥ
 * ͡
 *           ʤ
 ***********************************************************************/
static int
brdg_rput_data(queue_t *q, mblk_t *mp)
{
    uint32_t   portnum;
    struct     ether_header *ether;
    uchar_t    *rptr;         /* message  read ݥ */
    node_t     *snode;        /* ԤΥꥹȤǤ node_s ¤ */
    node_t     *dnode;        /* ԤΥꥹȤǤ node_s ¤ */    
    port_t     *port;         /*  queue  q_ptr  port ¤ */
    mblk_t     *dp;           /* ¾ port ؤžѤduplicate  message block */
    
    port = q->q_ptr;          /*  queue  q_ptr  port Ȥ */
    rptr = mp->b_rptr;        /* message  read pointer */           
    ether = (struct ether_header *)&rptr[0];
    snode = &node_hash_table[ETHER_HASH(ether->ether_shost)];

    if(snode->port == NULL){
        /*
         *  node ɬϿƤ餳ϤʤΤǡ
         * ̤ʤϤ
         */
        BRDG_PRINT0(CE_CONT,"Node not registered yet. Something wrong!!!!!\n");
        freemsg(mp);
        return(0);
    } 

    if( snode->port->rqueue == q){
        /*
         * ȯͥåȥɥ쥹줿 port_t  rqueue Ϥ queue Ʊ
         * ĤޤꡢͥåȥäƤž٤ѥåȤȽǤǤ
         * 襤ͥåȥɥ쥹 node Υȥõ
         */
        dnode = &node_hash_table[ETHER_HASH(ether->ether_dhost)];

        if( dnode->port != NULL ){

            /*
             * 襤ͥåȥɥ쥹ϥϥåơ֥ node ϿƤ롣
             */
            if (dnode->port->rqueue == q){
                /*
                 * ϥåơ֥ node ϿƤž٤
                 * ݡȤ queue ߤ queue ƱĤޤꡢž
                 * ɬפϤʤ˴
                 */

                BRDG_PRINT0(CE_CONT,"Dest addr is registerd. But not need to forward.\n");
                freemsg(mp);
                return(0);
            }
            /*
             * ž٤ݡȤǤ
             */
            if ( dnode->port->rqueue == NULL) {
                BRDG_PRINT0(CE_CONT,"Dest addr is registered. But queue does not exist\n");
            } else {
                if ( canputnext(WR(dnode->port->rqueue))){
                    BRDG_PRINT0(CE_CONT,"Dest addr is registered. Put the msg to appropriate queue\n");
                    /*
                     * node_s ˵ϿƤΤ read queue ʤΤ
                     * WR(9F) ޥȤä write queue  put(9E) 롣
                     */
                    putnext(WR(dnode->port->rqueue), mp);
                    return(0);
                } else {
                    BRDG_PRINT0(CE_CONT,"Dest addr is registerd. But can not put message.\n");
                    freemsg(mp);
                    return(0);
                }
            }
        } else {
            /*
             * 襤ͥåȥɥ쥹ϥϥåơ֥ΥȥϿ줤ʤ
             * ž٤ݡȤǤʤΤǡport_list ꥹȤäơʬʳ
             * port  putnext(9F) 롣
             */
            BRDG_PRINT_ETHER("dnode not found for this address: Ether = ", ether->ether_dhost);
            BRDG_PRINT1(CE_CONT, "dnodes's ETHER_HASH = %d\n", ETHER_HASH(ether->ether_dhost));
            
            for ( portnum = 0 ; portnum < MAXPORT ; portnum++){
                if((port_list[portnum].rqueue != NULL) && (port_list[portnum].rqueue != q)){
                    /*
                     * ߤ queue ȴϢ̵ port 
                     * ġport ¸ߤ롣-> ž٤ port 
                     */
                    if (canputnext(WR(port_list[portnum].rqueue))){
                        dp = dupmsg(mp);
                        BRDG_PRINT1(CE_CONT,"put message to port_list[%d] \n",portnum);
                        /*
                         * port ¤Τ˵ϿƤΤ read queue ʤΤ
                         * WR(9F) ޥȤä write queue  put 롣
                         */
                        putnext(WR(port_list[portnum].rqueue), dp);
                    }
                }
            } 
            freemsg(mp);
            return(0);
        } 
    } else { /* rqueue == q ? */
        /*
         * ¾ port  packet ž
         *  echo Ȼפ롣˴
         */
        freemsg(mp);
        return(0);
    }
    return(0);
}

/*****************************************************************************
 * brdg_register_node()
 * Ethernet ɥ쥹 node_s ¤ΤϿ롣
 * ⥸塼ΥХǡѹ뤳Ȥˤʤ롣
 * Хǡѹ뤿ˤϡ¾⡼ɤǤʤƤ ʤʤΤǡ
 * Υ롼ɬ qwriter(9F) ƤФ롣
 *
 *  
 *           q:  queue ¤ΤΥݥ
 *          mp:  message block Υݥ
 * ͡
 *           ʤ
 *****************************************************************************/
static void 
brdg_register_node(queue_t *q, mblk_t *mp)
{
    struct ether_header  *ether;
    uchar_t              *rptr;     /* message  read ݥ */
    node_t               *node;     /* ԤΥꥹȤǤ node_s ¤ */
    port_t               *port;     /*  queue  q_ptr  port ¤ */
    
    port  = q->q_ptr;   /*  queue  q_ptr  port Ȥ */
    rptr  = mp->b_rptr; /* message  read pointer */           
    ether = (struct ether_header *)&rptr[0];
    node  = &node_hash_table[ETHER_HASH(ether->ether_shost)];

    BRDG_PRINT1(CE_CONT,"register: ETHER_HASH = %d\n",ETHER_HASH(ether->ether_shost));
    BRDG_PRINT_ETHER("register : Ether = ", ether->ether_shost);
    
    bcopy(ether->ether_shost.ether_addr_octet, node->ether_addr.ether_addr_octet, ETHERADDRL);
    node->port = port;

    /*
     * ǡå¾ STREAM  queue  putnext(9F) 뤿
     * brdg_rput_data() Ƥ֡δؿ qwrite(9F) 饳Хå
     * ؿȤƸƤФƤΤǡbrdg_rput_data() ¾⡼ɤΤޤޤǤθƤӽФ
     * ˤʤ롣ϤޤʤưƱ¹Τǡ
     * ׸Ƥ
     */
    brdg_rput_data(q, mp);
    return;
}
/*****************************************************************************
 * brdg_print()
 *
 * ǥХåѴؿ
 *
 *  
 *           level  :  顼ο١cmn_err(9F) 
 *           format :  åνϥեޥåcmn_err(9F) 
 * ͡
 *           ʤ
 *****************************************************************************/
void
brdg_print(int level, char *format, ...)
{
    va_list     ap;
    char        buf[MAX_MSG];

    va_start(ap, format);
    vsprintf(buf, format, ap);    
    va_end(ap);
    cmn_err(level, "%s", buf);
    return;
}    
