/********************************************************************
 * brdgadm
 *
 * gcc brdgadm.c -lsocket -lnsl -o brdgadm 
 *
 * brdg ⥸塼Ԥ桼ޥ
 *
 * Usage: 
 *   brdgadm -a interface    # interface  Switch  port Ȥɲ
 *   brdgadm -d interface    # interface  Switch  port 
 *********************************************************************/

#include    <netinet/in.h>
#include    <sys/types.h>
#include    <unistd.h>
#include    <sys/socket.h>
#include    <sys/stropts.h>
#include    <errno.h>
#include    <sys/dlpi.h>
#include    <fcntl.h>
#include    <stdio.h>
#include    <sys/signal.h>
#include    <sys/stream.h>
#include    <string.h>
#include    <net/if.h>
#include    <netinet/if_ether.h>
#include    <netinet/in_systm.h>
#include    <netinet/tcp.h>
#include    <netinet/ip.h>

#define     MAXDLBUF        32768
#define     MAXWAIT         15    /* getmsg(2) Ԥ */
#define     MAXINSTANCE     10    /* 祤󥹥ֹ */
#define     FILENAME        "/etc/brdg.mid" /* mux_id ݻƤե */

int add_interface(char *);
int delete_interface(char *);
int list_interface();
int print_usage(char *);

main(int argc, char *argv[])
{
    int     opt,i;
    extern char *optarg;

    if( argc == 1 )
        list_interface();

    if ( getuid() != 0){
        fprintf(stderr, "Permission denied\n");
        exit(0);
    }
    
    while ((i = getopt (argc, argv, "d:a:")) != EOF) {
        switch (i){
            case 'd':
                delete_interface(optarg);                
                break;
            case 'a':
                add_interface(optarg);
                break;
            default:
                print_usage(argv[0]);
                break;
        }
    }
    exit(0);
}

dlattachreq(fd, ppa)
int     fd;
u_long  ppa;
{
        dl_attach_req_t attach_req;
        struct  strbuf  ctl;
        int     flags;
        
        attach_req.dl_primitive = DL_ATTACH_REQ;
        attach_req.dl_ppa = ppa;

        ctl.maxlen = 0;
        ctl.len = sizeof (attach_req);
        ctl.buf = (char *) &attach_req;

        flags = 0;

        if (putmsg(fd, &ctl, (struct strbuf*) NULL, flags) < 0)
                syserr("dlattachreq:  putmsg");
}

/*
 *  Service Access Point(=FlameType) bind ׵
 */
dlbindreq(fd, sap, max_conind, service_mode, conn_mgmt, xidtest)
int     fd;
u_long  sap;
u_long  max_conind;
u_long  service_mode;
u_long  conn_mgmt;
u_long  xidtest;
{
        dl_bind_req_t   bind_req;
        struct  strbuf  ctl;
        int     flags;

        bind_req.dl_primitive = DL_BIND_REQ;
        bind_req.dl_sap = sap;
        bind_req.dl_max_conind = max_conind;
        bind_req.dl_service_mode = service_mode;
        bind_req.dl_conn_mgmt = conn_mgmt;
        bind_req.dl_xidtest_flg = xidtest;

        ctl.maxlen = 0;
        ctl.len = sizeof (bind_req);
        ctl.buf = (char *) &bind_req;

        flags = 0;

        if (putmsg(fd, &ctl, (struct strbuf*) NULL, flags) < 0)
                syserr("dlbindreq:  putmsg");
}

/*
 *  bind ׵γǧ
 */
dlbindack(fd, bufp)
int     fd;
char    *bufp;
{
        union   DL_primitives   *dlp;
        struct  strbuf  ctl;
        int     flags;

        ctl.maxlen = MAXDLBUF;
        ctl.len = 0;
        ctl.buf = bufp;

        strgetmsg(fd, &ctl, (struct strbuf*)NULL, &flags, "dlbindack");

        dlp = (union DL_primitives *) ctl.buf;

        expecting(DL_BIND_ACK, dlp);

        if (flags != RS_HIPRI)
                err("dlbindack:  DL_OK_ACK was not M_PCPROTO");

        if (ctl.len < sizeof (dl_bind_ack_t))
                err("dlbindack:  short response ctl.len:  %d", ctl.len);
}

dlokack(fd, bufp)
int     fd;
char    *bufp;
{
        union   DL_primitives   *dlp;
        struct  strbuf  ctl;
        int     flags;

        ctl.maxlen = MAXDLBUF;
        ctl.len = 0;
        ctl.buf = bufp;

        strgetmsg(fd, &ctl, (struct strbuf*)NULL, &flags, "dlokack");

        dlp = (union DL_primitives *) ctl.buf;

        expecting(DL_OK_ACK, dlp);

        if (ctl.len < sizeof (dl_ok_ack_t))
                err("dlokack:  response ctl.len too short:  %d", ctl.len);

        if (flags != RS_HIPRI)
                err("dlokack:  DL_OK_ACK was not M_PCPROTO");

        if (ctl.len < sizeof (dl_ok_ack_t))
                err("dlokack:  short response ctl.len:  %d", ctl.len);
}

syserr(s)
char    *s;
{
        (void) perror(s);
        exit(1);
}

err(fmt, a1, a2, a3, a4)
char    *fmt;
char    *a1, *a2, *a3, *a4;
{
        (void) fprintf(stderr, fmt, a1, a2, a3, a4);
        (void) fprintf(stderr, "\n");
        (void) exit(1);
}

void sigalrm()
{
	(void) err("sigalrm:  TIMEOUT");
}

strgetmsg(fd, ctlp, datap, flagsp, caller)
int     fd;
struct  strbuf  *ctlp, *datap;
int     *flagsp;
char    *caller;
{
        int     rc;
        static  char    errmsg[80];

        /*
         * Start timer.
         */
        (void) signal(SIGALRM, sigalrm);
        if (alarm(MAXWAIT) < 0) {
                (void) sprintf(errmsg, "%s:  alarm", caller);
                syserr(errmsg);
        }

        /*
         * Set flags argument and issue getmsg().
         */
        *flagsp = 0;
        if ((rc = getmsg(fd, ctlp, datap, flagsp)) < 0) {
                (void) sprintf(errmsg, "%s:  getmsg", caller);
                syserr(errmsg);
        }

        /*
         * Stop timer.
         */
        if (alarm(0) < 0) {
                (void) sprintf(errmsg, "%s:  alarm", caller);
                syserr(errmsg);
        }

        if ((rc & (MORECTL | MOREDATA)) == (MORECTL | MOREDATA))
                err("%s:  MORECTL|MOREDATA", caller);
        if (rc & MORECTL)
                err("%s:  MORECTL", caller);
        if (rc & MOREDATA)
                err("%s:  MOREDATA", caller);

        /*
         * Check for at least sizeof (long) control data portion.
         */
        if (ctlp->len < sizeof (long))
                err("getmsg:  control portion length < sizeof (long):  %d", ctlp->len);
}

expecting(prim, dlp)
int     prim;
union   DL_primitives   *dlp;
{
        if (dlp->dl_primitive != (u_long)prim) {
                err("unexpected dlprim error\n");
                exit(1);
        }
}

/*
 * promiscast mode ذʹߤ뤿ꡣ
 */
dlpromisconreq(fd, level)
int     fd;
u_long  level;
{
        dl_promiscon_req_t      promiscon_req;
        struct  strbuf  ctl;
        int     flags;

        promiscon_req.dl_primitive = DL_PROMISCON_REQ;
        promiscon_req.dl_level = level;

        ctl.maxlen = 0;
        ctl.len = sizeof (promiscon_req);
        ctl.buf = (char *) &promiscon_req;

        flags = 0;

        if (putmsg(fd, &ctl, (struct strbuf*) NULL, flags) < 0)
                syserr("dlpromiscon:  putmsg");
}

/*
 * device(=/dev/???)  STREAMS ioctl Υᥤʬ
 */
strioctl(fd, cmd, timout, len, dp)
int     fd;
int     cmd;
int     timout;
int     len;
char    *dp;
{
        struct  strioctl        sioc;
        int     rc;
        
        sioc.ic_cmd = cmd;
        sioc.ic_timout = timout;
        sioc.ic_len = len;
        sioc.ic_dp = dp;

        rc = ioctl(fd, I_STR, &sioc);

        if (rc < 0)
                return (rc);
        else
                return (sioc.ic_len);
}

int print_usage(char *argv)
{
    printf("Usage: %s [ -a interface | -d interface] \n",argv);
    printf("Options:\n");
    printf(" -a interface\t: Add interface as switch port\n");
    printf(" -d interface\t: Delete interface from port list\n");    
    exit(0);
}

/*******************************************************
 * delete_interface()
 * ꤵ줿ͥåȥ󥿥եݡȤΥꥹȤ
 * /etc/brdg.mid ⥨ȥ
 * 
 *  
 *          interface : ͥåȥ󥿥ե̾
 * ͡
 *           int
 ******************************************************/
int delete_interface(char *interface)
{
    int     ip_fd;
    int     muxid = 0; 
    FILE    *fp;
    char    entry[128];
    char    *p;
    char    backup[1024];
    
    bzero(entry, 128);
    bzero(backup, 1024);
    
    if ((fp = fopen(FILENAME, "r")) == NULL) {
        fprintf(stderr,"Can't open %s\n", FILENAME);
        fclose(fp);        
        exit(0);
    } 
    /*
     * /etc/brdg.mid ե뤫ꤵ줿󥿡ե
     * ȥõʳΥ󥿡եΥȥ
     * backup ˥ԡƤ
     */
    while (fgets(entry, sizeof(entry), fp) != NULL){
        if (strncmp(entry, interface, strlen(interface)) == 0){
            p = strpbrk(entry, ":");                
            muxid = atoi(p+1);
        } else {
            strcat(backup, entry);
        }
    }        
    if (muxid == 0){
        fprintf(stderr,"Interface %s is not registerd\n",interface );
        fclose(fp);
        exit(0);
    }
    fclose(fp);

    if ((fp = fopen(FILENAME, "w")) == NULL) {
        fprintf(stderr,"Can't open %s\n", FILENAME);
        fclose(fp);        
        exit(0);
    }
    fputs(backup,fp);
    fclose(fp);
    
    printf("muxid %d is being deleted...",muxid);
    if ((ip_fd = open("/dev/ip", O_RDWR)) < 0){
        syserr("/dev/ip");
        exit(0);
    }    

    if (ioctl(ip_fd, I_PUNLINK, muxid) < 0) {
        printf("failed to unlink\n");
        exit(0);
    }
    printf("Done\n");
    exit(0);
}

/*******************************************************
 * add_interface()
 * ꤵ줿ͥåȥ󥿥ե Switch Υݡ
 * ȤɲáΤˡ󥿡ե̾
 * I_PUTLINK Ȥ muxid /etc/brdg.mid 
 * ¸롣
 * 
 *  
 *          interface : ͥåȥ󥿥ե̾
 * ͡
 *           int
 ******************************************************/
int add_interface(interface)
char        *interface;     /* command line Ϥ줿 interface      hme0         */
{
    int       i;    
    long      buf[MAXDLBUF];    
    union     DL_primitives *dlp;
    uint32_t  ppa;          /* PPA(Physical Point of address). interface  instance */
    uint32_t  if_fd, ip_fd; /* IP device Ѥ FD  Interface driver Ѥ FD               */
    uint32_t  muxid;        /* Multiplexer ID                                              */
    char      devname[30];  /* interface ̾ instance ä    hme           */
    char      devpath[30];  /* open() ˻ꤹ device file ؤ path /dev/hme      */
    char      *instance;    /* interface  instance ֹ档ppa Ȥʤ    0             */
    FILE      *fp;          /* /etc/brdg.mid פ File Pointer                             */
    char      entry[30];

    /*
     * /etc/brdg.mid ĴǤ˴¸Υȥ̵꤬ɤǧ
     */
    if ((fp = fopen(FILENAME, "r")) != NULL) {
        while (fgets(entry, sizeof(entry), fp) != NULL){
            if (strncmp(entry, interface, strlen(interface)) == 0){
                fprintf(stderr, "Interface %s is already registerd. Please remove first\n", interface);
                exit(0);
            }
        }
        fclose(fp);
    }
        
    for ( i = 0 ; i < MAXINSTANCE ; i++){
        if ((instance = strpbrk(interface, "0123456789")) == NULL)
            continue;
        ppa = atoi(instance);
        strncpy(devname, interface, instance - interface);
    }
    
    sprintf(devpath, "/dev/%s",devname);
    //printf("devname = %s, ppa = %d devpath = %s \n",devname, ppa, devpath);

    dlp = (union DL_primitives*) buf;

    /*
     * IP ǥХ󥿡եǥХ򥪡ץ
     */
    if ((ip_fd = open("/dev/ip", O_RDWR)) < 0)
        syserr("/dev/ip");        

    if((if_fd = open (devpath , O_RDWR)) < 0 )
        syserr(devpath);

    /*
     * PPA  attach
     */
    dlattachreq(if_fd, ppa);
    dlokack(if_fd, buf);
        
    /*
     * SAP(Service Access Point) 0 ˤ bind ׵
     */
    dlbindreq (if_fd, 0, 0, DL_CLDLS, 0, 0);
    dlbindack (if_fd, buf);
             
    /*
     * PROMISCOUS ⡼ɤءDL_PROMISC_SAPDL_PROMISC_PHYS ɤ ON 
     */
    dlpromisconreq(if_fd, DL_PROMISC_SAP);
    dlokack(if_fd, buf);        
    dlpromisconreq(if_fd, DL_PROMISC_PHYS);        
    dlokack(if_fd, buf);

    if (strioctl(if_fd, DLIOCRAW, -1, 0, NULL) < 0)
        syserr("DLIOCRAW");

    /*
     * Queue եå
     */
    if (ioctl(if_fd, I_FLUSH, FLUSHR) < 0)
        syserr("I_FLUSH");

    /*
     * Interface  stream  brdg ⥸塼 push
     */
    if (ioctl(if_fd, I_PUSH, "brdg") < 0)
        syserr("I_PUSH");

    /*
     * ip  stream  interface  stream  LINK
     * (PLINK = persist link)
     */
    muxid = ioctl(ip_fd, I_PLINK, if_fd);
    if( muxid < 0){
        perror("I_PLINK ioctl failed");
        exit(0);
    }
    
    if ((fp = fopen(FILENAME, "a")) == NULL) {
        fprintf(stderr,"Can't open %s\n", FILENAME);
        exit(0);	
    }

    sprintf(entry, "%s:%d\n", interface, muxid);
    fputs(entry,fp);
    fclose(fp);
    
    printf("%s successfully added. (muxid=%d)\n", interface, muxid);
    close(ip_fd);
    close(if_fd);
    return (0);
}

/***************************************************************
 * list_interface()
 * ߥݡȤϿƤͥåȥ󥿡եɽ
 * /etc/brdg.mid  cat ƤΤѤʤ
 *
 *    :
 *          ̵
 *  :
 *          int
 ***************************************************************/
int list_interface()
{
    int     muxid = 0; 
    FILE    *fp;
    char    entry[128];
    char    *p;
    char    backup[1024];
    
    if ((fp = fopen(FILENAME, "r")) == NULL) {
        fprintf(stderr,"Can't open %s\n", FILENAME);
        fclose(fp);        
        exit(0);
    } 
    printf("List of the interface regsitered as switch port\n");    
    while (fgets(entry, sizeof(entry), fp) != NULL){
        printf("\t%s\n", strtok(entry, ":"));
    }        
}
